#include <iostream>
#include <vector>

using namespace std;

int main()
{
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    size_t bin_count{};
    size_t number_count{};
    size_t max_count{};

    cerr << "Enter number count: ";
    cin >> number_count;
    vector<double> numbers(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cin >> numbers[i];
    cerr << "Enter bin count: ";
    cin >> bin_count;
    max_count = 0;
    }
    size_t mn = numbers[0];
    size_t
    mx = numbers[0];
    for (double x : numbers)
    {
        if (x < mn){
            mn = x;
        }
        else if (x > mx){
            mx = x;
        }
    }
    double bin_size = (mx - mn) / bin_count;
    vector<size_t> bins(bin_count);
    max_count = bins[0];
    for (size_t i = 0; i < number_count; i++){
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++){
            auto lo = mn + j * bin_size;
            auto hi = mn + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)){
                bins[j]++;
                found = true;
            }
            if (bins[j] > max_count){
                max_count = bins[j];
            }
        }
        if (!found){
            bins[bin_count - 1]++;
        }
        if (bins[bin_count - 1] > max_count){
            max_count = bins[bin_count - 1];
        }
    }
    if (max_count > MAX_ASTERISK){
        vector<size_t> hights(bin_count);
        for (size_t i = 0; i < bin_count; i++){
            size_t height = MAX_ASTERISK * (static_cast<double>(bins[i]) / max_count);
            hights[i] = height;
        }

        for (size_t i = 0; i < bin_count; i++){
            printf("%3d|", bins[i]);
            for (size_t j = 0; j < hights[i]; j++){
                cout<<"*";
            }
            cout << endl;
        }
    }
    else{
        for (size_t i = 0; i < bin_count; i++)
        {
            printf("%3d|", bins[i]);
            for (size_t j = 0; j < bins[i]; j++){
                cout<<"*";
            }
            cout << endl;
        }
    }
}
